#!/usr/bin/python

# (c) Simon Burton 2001
# this code is licensed GPL, see file LICENSE
# play a raw sound file

import os,sys,string
from fcntl import ioctl
try:
  from soundcard import *
except ImportError:
  import h2py
  h2py.send("/usr/include/sys/soundcard.h")
  from soundcard import *

def _ioctl(fmt,fd,ctl,i):
  return struct.unpack(fmt,
    ioctl(fd,ctl,struct.pack(fmt,i)))[0]

bufsz=4096
try:
  file=open(sys.argv[1])
except:
  print "usage : pl.py [soundfile.raw]"
  sys.exit(0)
print "opened "+sys.argv[1]
device=open("/dev/dsp","w")
devfd=device.fileno()
print _ioctl('i',devfd,SNDCTL_DSP_GETFMTS,AFMT_QUERY)
print _ioctl('i',devfd,SNDCTL_DSP_SETFMT,AFMT_S16_LE)
print _ioctl('i',devfd,SNDCTL_DSP_STEREO,1)
print _ioctl('i',devfd,SNDCTL_DSP_SPEED,44100)
buf=1
while buf:
  buf=os.read(file.fileno(),bufsz)
  os.write(devfd,buf)


